//by Chad Serrant
#include "allegro.h"
#include "dataObj.h"
#include "unitList.h"
#include <vector>
using namespace std;

#include "unitGraphics.h"
#include "hitbox.h"
#include "loader.h"
#include "unit.h"
#include "playerUnit.h"

class battleMain {

public:

  battleMain ();

  //initialization
  int init ();
  void restart (bool, bool);
  int go ();

  //accessors
  BITMAP * getBuffer ();
  int getNextRound ();
  int getBattleRound ();
  dataObj * getDataObj ();

  //modifiers
  void setDataObj (dataObj *);
  void setNextRound (int);
  void setBattleRound (int);

  //rendering
  void draw (BITMAP *, BITMAP *);
  void drawBackground (BITMAP *, BITMAP *);
  void drawUnits (BITMAP *);
  void drawCursor (BITMAP *);
  void drawDisplay (BITMAP *);
  void drawHPBar (BITMAP *, float);
  void drawTimerBar (BITMAP *, int);
  void drawStatus (BITMAP *, playerUnit *);

  //model processing
  void applyInput ();

  ~battleMain ();

 protected:

  //fields
  unitList * units;

  BITMAP * buffer;
  BITMAP * gameOutput;
  BITMAP * youWin;
  BITMAP * youLose;
  BITMAP * introPic;

  BITMAP * clockPic;
  BITMAP * heartPic;
  BITMAP * dontHitPic;

  BITMAP * invicPic;
  BITMAP * stunnedPic;
  BITMAP * speedUpPic;
  BITMAP * speedDownPic;
  BITMAP * kbDownPic;
  BITMAP * nojuicePic;
  BITMAP * morejuicePic;
  BITMAP * dmgDownPic;

  dataObj *dO;
  int battleMode;
  int displayTimer;
  int stageTime;
  int battleRound;
  int nextRound;

  loader * lder;
  DATAFILE * picData;
};
