#include "allegro.h"
#include "dataObj.h"
#include "config.h"
#include "battleMain.h"
#include "gameConstants.h"

#include <fstream>
#include <iostream>

#include <vector>
using namespace std;

#ifndef M_PI
   #define M_PI   3.14159
#endif

/* convert radians to degrees */
#define DEG(n)    ((n) * 180.0 / M_PI)

int menuMsg = mainConfigRestart;
bool quitProgram = false;

battleMain * bM;
dataObj * dO;
config * cf;

///////////////////
//   PROTOTYPES   //
////////////////////

int mainInitialize ();

/////////////////////

int mainInitialize ()
{
  int gfxmode = GFX_AUTODETECT_WINDOWED;
  int bminit;

  bM = new battleMain ();
  dO = new dataObj ();
  cf = new config ();
  
  //read variables from config file here
  dO -> readConfig ();

  gfxmode = dO -> getVideoSettings () -> getGfxDriver ();

  set_color_depth (dO -> getVideoSettings () -> getColorDepth ());
  if (set_gfx_mode(gfxmode, dO -> getVideoSettings () -> getResolutionX (), dO -> getVideoSettings () -> getResolutionY (), 0, 0) != 0) {
    if (set_gfx_mode(GFX_SAFE, 640, 480, 0, 0) != 0) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
      allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
      return 1;
    }
  }

  bM -> setDataObj (dO);
  bminit = bM -> init ();
  //has to come after bM sets the graphics
  cf -> setGfx (dO -> getDatafile ());

  return bminit;
}

int main(void)
{
  if (allegro_init() != 0)
    return 1;
  install_keyboard();
  install_timer();
  install_mouse();

  if (mainInitialize () == 0)
    {
      while (!quitProgram) {
	
	switch (menuMsg)
	  {
	  case (mainConfigContinue):
	    menuMsg = cf -> go (bM -> getDataObj ());
	    break;
	  case (mainConfigRestart):
	    menuMsg = cf -> go (bM -> getDataObj ());
	    break;
	 case (mainBattleRestart):
	   //need to define "campaigns" to store the first round.
	   bM -> init ();
	   bM -> setNextRound (0);
	   bM -> setBattleRound (0);
	   bM -> restart (true, true);
	   menuMsg = bM -> go ();
	   break;
	  case (mainBattleContinue):
	    menuMsg = bM -> go ();
	    //draw the buffer to the screen
	    vsync();
	   blit(bM -> getBuffer (), screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	   break;
	  case (mainQuit):
	    quitProgram = true;
	    break;
	  }
      }
    }
  return 0;
}

END_OF_MAIN();
