#include "unitList.h"
#include "playerAimUnit.h"

#include "allegro.h"
#include "dataObj.h"
#include "unit.h"
#include "inputObj.h"
#include "cursor.h"
#include "gameConstants.h"
#include "tasmMath.h"

#include <vector>
using namespace std;

playerAimUnit :: playerAimUnit ()
{

}

void playerAimUnit :: init (int param1, int param2, int param3)
{
  hpToGivePlayer = 0;
  moveType = moveTypeStuckToOwner;
  hitPoints = 20000;
  maxHP = 30000;
  statusAilment -> at (statusAilmentInvic) = 30000;
  immuneToAilments = true;
  ignoreWall = true;
  affiliation = affiliationNeutral;
  aimAngle = itofix (0);
}

void playerAimUnit :: processInput (dataObj * dO, unitList * units)
{
  int cursorX = 0, cursorY = 0;
  unit * ownUnit = NULL;
  fixed micX = itofix (0), micY = itofix (0), micDist = itofix (0), micAngle = itofix (0), turnDist = itofix (0);
  int ct = dO -> getInputObj () -> getControlThreshold ();

  //change angle to point at mouse. The arena's scaling is taken into account.
  dO -> getInputObj () -> getCursor () -> getMouseMickeys (cursorX, cursorY);

  //transformation for screen vs cartesian coordinates
  micX = itofix (-1 * cursorX);
  micY = itofix (cursorY);
  micDist = fixhypot (micX, micY);

  ownUnit = units -> at (getOwnerID ());

  if (ownUnit != NULL && micDist > itofix (1)) //insert threshold value here
    {
      //get angle
      if (cursorY == 0 && cursorX < 0)
	micAngle = itofix (-64);
      else if (cursorY == 0  && cursorX > 0)
	micAngle = itofix (64);
      else
	micAngle = fixatan (fixdiv (micX, micY));
      
      //correct the atan response: answers will only range from -64 to 64, crossing 0 (point up only)...need to rotate answer if it should be pointing down

      if (micY > itofix (0))
	micAngle -= itofix (128);
	      
      //keeps micAngle in the range of -256 to 256
      micAngle = micAngle ^ 256;
      
      //combine control stlye 1&2
      //use fast mouse jerks to quickly get the angle
      //move slowly to fine tune the angle
      //NOTE: Need control threshold values to separate fast vs slow mouse movements
      if (micDist > itofix (ct))
	{
	  //Idea #1: direct - make the cursor point in the direction the mouse moves. Will need to control the threshold value so when user releases mouse, doesn't turn around (might just want only fullscreen for this, since the mouse WILL scroll outside of the window.) Also, it's inaccurate.
	  drawAngle = micAngle;
	}
      else
	{
	  //Idea #2: rotate - the mouse direction acts as a rotation force to 'rotate' the cursor around. It may be unintuitive for large rotations.
	  //ok, compare the angles
	  turnDist = angleDist (micAngle, drawAngle);
	  //ok rotate based on the difference between the angles
	  drawAngle += turnDist / 10;
	}
    }
}

playerAimUnit :: ~playerAimUnit ()
{

}
