#ifndef _VIDEOSETTINGS_H_
#define _VIDEOSETTINGS_H_

#include "allegro.h"

#include <vector>
using namespace std;

class videoSettings
{
public:
  videoSettings ();
  ~videoSettings ();

  //   general video settings
public:
  void getCamera (int &, int &);
  void setCamera (int, int);
  void getResolution (int &, int &);
  int getResolutionX ();
  int getResolutionY ();
  void setResolution (int , int);

  void setBkgCols (float hue, float sat);
  void getBkg (int & r, int & g, int & b);
  void getTransCol (int & r, int & g, int & b);

  void setObjectPositions (int, int);

  int getArenaPosX ();
  int getArenaPosY ();
  fixed getArenaScale ();

  int getHPBarStartX ();
  int getHPBarStartY ();
  int getHPBarSizeX ();
  int getHPBarSizeY ();

  int getColorDepth ();
  void setColorDepth (int);

  int getGfxDriver ();
  void setGfxDriver (int);

protected:
  int cameraX, cameraY;
  int resolutionX, resolutionY;
  int backgroundR, backgroundG, backgroundB;
  float bkgHue;
  float bkgSat;
  int bkgR, bkgG, bkgB;
  int transR, transG, transB;
  int colorDepth;
  int gfxDriver;

  int arenaPosX, arenaPosY;
  fixed arenaScale;

  int hpStartX, hpStartY;
  int hpSizeX, hpSizeY;
};

#endif
